import{s as Oe,n as Le,o as Ee}from"../chunks/scheduler.8c3d61f6.js";import{S as He,i as Ie,g as a,s as n,r as u,A as qe,h as d,f as t,c as i,j as M,u as p,x as v,k as P,y as r,a as c,v as f,d as m,t as h,w as g}from"../chunks/index.da70eac4.js";import{D as W}from"../chunks/Docstring.6b390b9a.js";import{H as $e,E as Ae}from"../chunks/EditOnGithub.1e64e623.js";function Fe(xe){let _,j,G,Y,T,J,y,Se='The <code>KDPM2DiscreteScheduler</code> is inspired by the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',Q,w,Me='The original codebase can be found at <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">crowsonkb/k-diffusion</a>.',X,K,Z,o,C,le,A,Pe=`KDPM2DiscreteScheduler is inspired by the DPMSolver2 and Algorithm 2 from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of
Diffusion-Based Generative Models</a> paper.`,ue,F,Te=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,pe,D,k,fe,U,ye=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,me,$,O,he,V,we="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",ge,x,L,_e,z,Ke="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",be,S,E,ve,N,Ce=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,ee,H,te,b,I,De,B,ke="Base class for the output of a scheduler’s <code>step</code> function.",se,q,re,R,ne;return T=new $e({props:{title:"KDPM2DiscreteScheduler",local:"kdpm2discretescheduler",headingTag:"h1"}}),K=new $e({props:{title:"KDPM2DiscreteScheduler",local:"diffusers.KDPM2DiscreteScheduler",headingTag:"h2"}}),C=new W({props:{name:"class diffusers.KDPM2DiscreteScheduler",anchor:"diffusers.KDPM2DiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"use_exponential_sigmas",val:": Optional = False"},{name:"use_beta_sigmas",val:": Optional = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.KDPM2DiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.KDPM2DiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.KDPM2DiscreteScheduler.use_exponential_sigmas",description:`<strong>use_exponential_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use exponential sigmas for step sizes in the noise schedule during the sampling process.`,name:"use_exponential_sigmas"},{anchor:"diffusers.KDPM2DiscreteScheduler.use_beta_sigmas",description:`<strong>use_beta_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use beta sigmas for step sizes in the noise schedule during the sampling process. Refer to <a href="https://huggingface.co/papers/2407.12173" rel="nofollow">Beta
Sampling is All You Need</a> for more information.`,name:"use_beta_sigmas"},{anchor:"diffusers.KDPM2DiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.KDPM2DiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.KDPM2DiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L75"}}),k=new W({props:{name:"scale_model_input",anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L194",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),O=new W({props:{name:"set_begin_index",anchor:"diffusers.KDPM2DiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L184"}}),L=new W({props:{name:"set_timesteps",anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L224"}}),E=new W({props:{name:"step",anchor:"diffusers.KDPM2DiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/deis#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L440",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/deis#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/main/en/api/schedulers/deis#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),H=new $e({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),I=new W({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_utils.py#L60"}}),q=new Ae({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/dpm_discrete.md"}}),{c(){_=a("meta"),j=n(),G=a("p"),Y=n(),u(T.$$.fragment),J=n(),y=a("p"),y.innerHTML=Se,Q=n(),w=a("p"),w.innerHTML=Me,X=n(),u(K.$$.fragment),Z=n(),o=a("div"),u(C.$$.fragment),le=n(),A=a("p"),A.innerHTML=Pe,ue=n(),F=a("p"),F.innerHTML=Te,pe=n(),D=a("div"),u(k.$$.fragment),fe=n(),U=a("p"),U.textContent=ye,me=n(),$=a("div"),u(O.$$.fragment),he=n(),V=a("p"),V.textContent=we,ge=n(),x=a("div"),u(L.$$.fragment),_e=n(),z=a("p"),z.textContent=Ke,be=n(),S=a("div"),u(E.$$.fragment),ve=n(),N=a("p"),N.textContent=Ce,ee=n(),u(H.$$.fragment),te=n(),b=a("div"),u(I.$$.fragment),De=n(),B=a("p"),B.innerHTML=ke,se=n(),u(q.$$.fragment),re=n(),R=a("p"),this.h()},l(e){const s=qe("svelte-u9bgzb",document.head);_=d(s,"META",{name:!0,content:!0}),s.forEach(t),j=i(e),G=d(e,"P",{}),M(G).forEach(t),Y=i(e),p(T.$$.fragment,e),J=i(e),y=d(e,"P",{"data-svelte-h":!0}),v(y)!=="svelte-1r1y5wx"&&(y.innerHTML=Se),Q=i(e),w=d(e,"P",{"data-svelte-h":!0}),v(w)!=="svelte-loovl7"&&(w.innerHTML=Me),X=i(e),p(K.$$.fragment,e),Z=i(e),o=d(e,"DIV",{class:!0});var l=M(o);p(C.$$.fragment,l),le=i(l),A=d(l,"P",{"data-svelte-h":!0}),v(A)!=="svelte-iytw69"&&(A.innerHTML=Pe),ue=i(l),F=d(l,"P",{"data-svelte-h":!0}),v(F)!=="svelte-linuuh"&&(F.innerHTML=Te),pe=i(l),D=d(l,"DIV",{class:!0});var ie=M(D);p(k.$$.fragment,ie),fe=i(ie),U=d(ie,"P",{"data-svelte-h":!0}),v(U)!=="svelte-1rkfgpx"&&(U.textContent=ye),ie.forEach(t),me=i(l),$=d(l,"DIV",{class:!0});var oe=M($);p(O.$$.fragment,oe),he=i(oe),V=d(oe,"P",{"data-svelte-h":!0}),v(V)!=="svelte-1k141rk"&&(V.textContent=we),oe.forEach(t),ge=i(l),x=d(l,"DIV",{class:!0});var ae=M(x);p(L.$$.fragment,ae),_e=i(ae),z=d(ae,"P",{"data-svelte-h":!0}),v(z)!=="svelte-1vzm9q"&&(z.textContent=Ke),ae.forEach(t),be=i(l),S=d(l,"DIV",{class:!0});var de=M(S);p(E.$$.fragment,de),ve=i(de),N=d(de,"P",{"data-svelte-h":!0}),v(N)!=="svelte-hi84tp"&&(N.textContent=Ce),de.forEach(t),l.forEach(t),ee=i(e),p(H.$$.fragment,e),te=i(e),b=d(e,"DIV",{class:!0});var ce=M(b);p(I.$$.fragment,ce),De=i(ce),B=d(ce,"P",{"data-svelte-h":!0}),v(B)!=="svelte-6ojmkw"&&(B.innerHTML=ke),ce.forEach(t),se=i(e),p(q.$$.fragment,e),re=i(e),R=d(e,"P",{}),M(R).forEach(t),this.h()},h(){P(_,"name","hf:doc:metadata"),P(_,"content",Ue),P(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){r(document.head,_),c(e,j,s),c(e,G,s),c(e,Y,s),f(T,e,s),c(e,J,s),c(e,y,s),c(e,Q,s),c(e,w,s),c(e,X,s),f(K,e,s),c(e,Z,s),c(e,o,s),f(C,o,null),r(o,le),r(o,A),r(o,ue),r(o,F),r(o,pe),r(o,D),f(k,D,null),r(D,fe),r(D,U),r(o,me),r(o,$),f(O,$,null),r($,he),r($,V),r(o,ge),r(o,x),f(L,x,null),r(x,_e),r(x,z),r(o,be),r(o,S),f(E,S,null),r(S,ve),r(S,N),c(e,ee,s),f(H,e,s),c(e,te,s),c(e,b,s),f(I,b,null),r(b,De),r(b,B),c(e,se,s),f(q,e,s),c(e,re,s),c(e,R,s),ne=!0},p:Le,i(e){ne||(m(T.$$.fragment,e),m(K.$$.fragment,e),m(C.$$.fragment,e),m(k.$$.fragment,e),m(O.$$.fragment,e),m(L.$$.fragment,e),m(E.$$.fragment,e),m(H.$$.fragment,e),m(I.$$.fragment,e),m(q.$$.fragment,e),ne=!0)},o(e){h(T.$$.fragment,e),h(K.$$.fragment,e),h(C.$$.fragment,e),h(k.$$.fragment,e),h(O.$$.fragment,e),h(L.$$.fragment,e),h(E.$$.fragment,e),h(H.$$.fragment,e),h(I.$$.fragment,e),h(q.$$.fragment,e),ne=!1},d(e){e&&(t(j),t(G),t(Y),t(J),t(y),t(Q),t(w),t(X),t(Z),t(o),t(ee),t(te),t(b),t(se),t(re),t(R)),t(_),g(T,e),g(K,e),g(C),g(k),g(O),g(L),g(E),g(H,e),g(I),g(q,e)}}}const Ue='{"title":"KDPM2DiscreteScheduler","local":"kdpm2discretescheduler","sections":[{"title":"KDPM2DiscreteScheduler","local":"diffusers.KDPM2DiscreteScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function Ve(xe){return Ee(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ge extends He{constructor(_){super(),Ie(this,_,Ve,Fe,Oe,{})}}export{Ge as component};
